
#include <stdio.h>

#include "video.h"

#include "test_FDC.h"
#include "driver_FDC.h"

__sfr __at 		0xce 	rDMD;

// porty k mapovani standardni pameti
__sfr __at 		0xe0 	rMAPE0;
__sfr __at 		0xe1 	rMAPE1;
__sfr __at 		0xe2 	rMAPE2;
__sfr __at 		0xe3 	rMAPE3;
__sfr __at 		0xe4 	rMAPE4;
__sfr __at 		0xe5 	rMAPE5;
__sfr __at 		0xe6 	rMAPE6;



void prg_error ( unsigned char err_code ) {
    while ( 1 ) {
        rBCOLOR = err_code;
        rBCOLOR = 0x00;
    };
}


void main ( void ) {

    char err = 0;

    unsigned char drive_id = FDC_DRIVE0;

    /* testovaci hodnoty pro Seek a readSector */
    unsigned char track = 10;
    unsigned char sector = 2;
    unsigned char side = 1;

    unsigned int sector_size;
    void *dma_addr = (void *) 0x6000;
    DISCADDR_t sector_addr;

    rBCOLOR = BLACK;

    /* mame pripojen radic? */
    if ( 0 != testFDC_isPresent () ) prg_error ( 1 );


    /* roztocit motor a vybrat mechaniku */
    FDC_doMotorOn ();
    FDC_doSelectDrive ( drive_id );


    /* provedeme restorte (TRK00) */
    err = FDC_doRestore ();
    if ( err ) prg_error ( err );


    /* vyzkousime step in (nahoru) / out (dolu) */
    err = FDC_doStepIn ();
    if ( err ) prg_error ( err );
    err = FDC_doStepOut ();
    if ( err ) prg_error ( err );


    /* seek na pozadovanou stopu */
    err = FDC_doSeek ( track );
    if ( err ) prg_error ( err );


    /* precteni FDC adresy */
    FDC_setSide ( side );
    FDC_setSector ( sector );
    err = FDC_doReadAddr ( &sector_addr );
    if ( err ) prg_error ( err );



    /* precteni sektoru */

    /* velikost sektoru si ted nacteme z FDC, jinak by mela byt nastavena nekde v konfiguracni tabulce */
    if ( sector_addr.sector_size == 0 ) {
        sector_size = 128;
    } else if ( sector_addr.sector_size == 1 ) {
        sector_size = 256;
    } else {
        sector_size = 512;
    };
    
#ifdef FDC_SUPPORT_HDD
    FDC_setDensity ( FDC_DENSITY_DD );
#endif
    err = FDC_doReadSector ( sector_size, dma_addr, FDC_INVERT_DATA );

    if ( err ) prg_error ( err );



    FDC_doMotorOff ();
    
    rBCOLOR = GREEN;
    
    while ( 1 ) {};
}
